%define section		free

%define gccsuffix	%{nil}
%define	origin		gcj%{gccsuffix}
%define priority	1420
%define	javaver		1.4.2
%define buildver	0
%define gccver		3.4
%define jgcver		1.0.11

%define name		java-%{javaver}-%{origin}-compat
%define version		%{javaver}.%{buildver}
%define release		6jpp
%define cname           java-%{javaver}-%{origin}

%define	sdklnk		java-%{javaver}-%{origin}
%define	jrelnk		jre-%{javaver}-%{origin}
%define	sdkdir		%{cname}-%{version}
%define	jredir		%{sdkdir}/jre
%define sdkbindir	%{_jvmdir}/%{sdklnk}/bin
%define jrebindir	%{_jvmdir}/%{jrelnk}/bin
%define jvmjardir       %{_jvmjardir}/%{cname}-%{version}

Name:		%{name}
Version:	%{version}
Release:	%{release}
Epoch:		0
Summary:	JPackage runtime scripts for GCJ

Group:		Development/Languages
License:	GPL
URL:		ftp://sources.redhat.com/pub/rhug/java-gcj-compat
Source0:        java-gcj-compat-%{jgcver}.tar.gz
Vendor:         JPackage Project
Distribution:   JPackage
BuildArch:      noarch
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	jpackage-utils >= 0:1.5, sed
BuildRequires:	gcc%{gccsuffix}-java >= %{gccver}
BuildRequires:	eclipse-ecj
Requires:	gcc%{gccsuffix}-java >= %{gccver}
Requires:	libgcj%{gccsuffix} >= %{gccver}
# Requires:	gjdoc
Provides:	jre-%{javaver}-%{origin} = %{epoch}:%{version}-%{release}
Provides:	jre-%{origin} = %{epoch}:%{version}-%{release}
Provides:	jre-%{javaver}, java-%{javaver}, jre = %{javaver}
Provides:	java-%{origin} = %{epoch}:%{version}-%{release}
Provides:	java = %{javaver}
Provides:	jndi, jdbc-stdext

%description
This package contains shell scripts and symbolic links to simulate a
JPackage Java runtime environment with GCJ.

%package devel
Summary:	JPackage development scripts for GCJ
Group:		Development/Tools
Requires:	/usr/sbin/update-alternatives
Provides:       java-sdk-%{javaver}-%{origin} = %{epoch}:%{version}
Provides:	java-sdk-%{javaver}
Provides:       java-sdk-%{origin} = %{epoch}:%{version}
Provides:	java-sdk = %{javaver}
Provides:       java-%{javaver}-devel
Provides:	java-devel-%{origin} = %{epoch}:%{version}
Provides:       java-devel = %{javaver}
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	eclipse-ecj

%description devel
This package contains shell scripts and symbolic links to simulate a
JPackage Java development environment with GCJ.

%prep
%setup -q -n java-gcj-compat-%{jgcver}

%build
%configure --disable-symlinks --with-gcc-suffix=%{gccsuffix}
make

%install
rm -rf $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT install

install -dm 755 $RPM_BUILD_ROOT%{_jvmdir}/%{cname}-%{version}/jre/lib
install -dm 755 $RPM_BUILD_ROOT%{_jvmdir}/%{cname}-%{version}/include

# create dummy versions of these files so that this rpm can own them
touch $RPM_BUILD_ROOT%{_jvmdir}/%{cname}-%{version}/jre/lib/rt.jar
touch $RPM_BUILD_ROOT%{_jvmdir}/%{cname}-%{version}/include/jni.h

# extensions handling
install -dm 755 $RPM_BUILD_ROOT%{jvmjardir}

# versionless symlinks
pushd $RPM_BUILD_ROOT%{_jvmdir}
   ln -s %{jredir} %{jrelnk}
   ln -s %{sdkdir} %{sdklnk}
popd

pushd $RPM_BUILD_ROOT%{_jvmjardir}
   ln -s %{sdkdir} %{jrelnk}
   ln -s %{sdkdir} %{sdklnk}
popd

# generate file lists
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type d \
  | sed 's|'$RPM_BUILD_ROOT'|%dir |' >  %{name}-%{version}-all.files
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type f -o -type l \
  | sed 's|'$RPM_BUILD_ROOT'||'      >> %{name}-%{version}-all.files

cat %{name}-%{version}-all.files \
  > %{name}-%{version}.files

find $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/bin -type f \
  | sed "s|^$RPM_BUILD_ROOT||"      > %{name}-%{version}-sdk-bin.files

%clean
rm -rf $RPM_BUILD_ROOT

%post
update-alternatives \
  --install %{_bindir}/java java %{jrebindir}/java %{priority} \
  --slave %{_jvmdir}/jre          jre          %{_jvmdir}/%{jrelnk} \
  --slave %{_jvmjardir}/jre       jre_exports  %{_jvmjardir}/%{jrelnk} \
  --slave %{_bindir}/rmiregistry  rmiregistry  %{jrebindir}/rmiregistry

update-alternatives \
  --install %{_jvmdir}/jre-%{origin} \
      jre_%{origin} %{_jvmdir}/%{jrelnk} %{priority} \
  --slave %{_jvmjardir}/jre-%{origin} \
      jre_%{origin}_exports %{_jvmjardir}/%{jrelnk}

update-alternatives \
  --install %{_jvmdir}/jre-%{javaver} \
      jre_%{javaver} %{_jvmdir}/%{jrelnk} %{priority} \
  --slave %{_jvmjardir}/jre-%{javaver} \
      jre_%{javaver}_exports %{_jvmjardir}/%{jrelnk}

ln -sf \
  %{_javadir}/libgcj-`gcj%{gccsuffix} --version | head -n 1 | awk '{ print $3 }'`.jar \
  %{_jvmdir}/%{cname}-%{version}/jre/lib/rt.jar

%post devel

update-alternatives \
  --install %{_bindir}/javac javac %{sdkbindir}/javac %{priority} \
  --slave %{_jvmdir}/java     java_sdk          %{_jvmdir}/%{sdklnk} \
  --slave %{_jvmjardir}/java  java_sdk_exports  %{_jvmjardir}/%{sdklnk} \
  --slave %{_bindir}/javadoc  javadoc           %{sdkbindir}/javadoc \
  --slave %{_bindir}/javah    javah             %{sdkbindir}/javah \
  --slave %{_bindir}/jar      jar               %{sdkbindir}/jar \
  --slave %{_bindir}/rmic     rmic              %{sdkbindir}/rmic

update-alternatives \
  --install %{_jvmdir}/java-%{origin} \
      java_sdk_%{origin} %{_jvmdir}/%{sdklnk} %{priority} \
  --slave %{_jvmjardir}/java-%{origin} \
      java_sdk_%{origin}_exports %{_jvmjardir}/%{sdklnk}

update-alternatives \
  --install %{_jvmdir}/java-%{javaver} \
      java_sdk_%{javaver} %{_jvmdir}/%{sdklnk} %{priority} \
  --slave %{_jvmjardir}/java-%{javaver} \
      java_sdk_%{javaver}_exports %{_jvmjardir}/%{sdklnk}

ln -sf \
  `gcj%{gccsuffix} -print-file-name=include/jni.h` \
  %{_jvmdir}/%{cname}-%{version}/include/jni.h

%postun
if [ $1 -eq 0 ] ; then
   update-alternatives --remove java %{jrebindir}/java
   update-alternatives --remove jre_%{origin}  %{_jvmdir}/%{jrelnk}
   update-alternatives --remove jre_%{javaver} %{_jvmdir}/%{jrelnk}
fi

%postun devel
if [ $1 -eq 0 ] ; then
   update-alternatives --remove javac %{sdkbindir}/javac
   update-alternatives --remove java_sdk_%{origin}  %{_jvmdir}/%{sdklnk}
   update-alternatives --remove java_sdk_%{javaver} %{_jvmdir}/%{sdklnk}
fi

# gcc-java requires libgcj and provides the gcj we run for the version
# string
%triggerin -- gcc%{gccsuffix}-java > %{gccver}
{
  ln -sf \
    %{_javadir}/libgcj-`gcj%{gccsuffix} --version | head -n 1 | awk '{ print $3 }'`.jar \
    %{_jvmdir}/%{cname}-%{version}/jre/lib/rt.jar
} || :

# gcc-java requires libgcj-devel which provides jni.h
%triggerin devel -- gcc%{gccsuffix}-java > %{gccver}
{
  ln -sf \
    `gcj%{gccsuffix} -print-file-name=include/jni.h` \
    %{_jvmdir}/%{cname}-%{version}/include/jni.h
} || :

%files -f %{name}-%{version}.files
%defattr(-,root,root,-)
%doc
%dir %{_jvmdir}/%{sdkdir}
%dir %{jvmjardir}
#%{jvmjardir}/*.jar
%{_jvmdir}/%{jrelnk}
%{_jvmjardir}/%{jrelnk}
#%{_jvmprivdir}/*

%files devel -f %{name}-%{version}-sdk-bin.files
%defattr(-,root,root)
%doc
%dir %{_jvmdir}/%{sdkdir}/bin
%{_jvmdir}/%{sdkdir}/lib
%{_jvmdir}/%{sdkdir}/include
%{_jvmdir}/%{sdklnk}
%{_jvmjardir}/%{sdklnk}

%changelog
* Wed Feb  2 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-6jpp
- Remove Obsoletes and Conflicts.
- Comment out gjdoc requirement.

* Tue Feb  1 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-4jpp
- Remove gjdoc version requirement.
- Change java-gcj-compat version number.

* Tue Feb  1 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-4jpp
- Import java-gcj-compat 1.0.11.
- Require gjdoc.

* Tue Feb  1 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-4jpp
- Add jni.h symlink.
- Install rt.jar as an unmanaged symlink.
- Conflict and obsolete old java-gcj-compat rpms.
- Import java-gcj-compat 1.0.9.

* Mon Jan 24 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-3jpp
- Import java-gcj-compat 1.0.8.

* Thu Jan 13 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-2jpp
- Make jvmjardir use cname, not name.

* Wed Jan 12 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-1jpp
- Initial build.
